(function($, owner) {
	//服务器 
	var baseUrl = "https://wenqu.co/ask";
	var imageUrl = "https://wenqu.co/ask/";
//	var baseUrl = "http://192.168.0.127:8080/ask";
//	var imageUrl = "http://192.168.0.127:8080/ask/";

	owner.getBaseUrl = function() {
		return baseUrl;
	}
	owner.getUrl = function() {
		return imageUrl;
	}
//	owner.getUploadUrl = function() { 不能   
//			return uploadUrl;
//		}
		/**
		 * @description 发送POST请求
		 * @param {String} url 请求url 不需要写host:port
		 * @param {Object} postData 请求发送的数据
		 * @param {Object} successFun_Cb 成功（success）调用
		 * @param {Object} errorFun_Cb 失败（error）调用
		 */
	owner.post = function(url, postData, successFun_Cb, errorFun_Cb) {
		if (!url) {
			throw Error("url 不正确！");
			return false;
		}
		if (url && !url.match("^/")) {
			url = "/" + url;
		}
		var stateUser = owner.getState();
		if (stateUser.token) {
			postData["token"] = stateUser.token;
		}
		$.ajax(baseUrl + url, {
			type: "post",
			data: postData,
			timeout: 20000,
			success: function(data) {
				if (data.ret == -2) { // 用户信息过期,token 不对
					owner.setState();
				}
				return successFun_Cb(data);
			},
			error: function(data) {
				if (errorFun_Cb) {
					return errorFun_Cb(data);
				} else {
					return successFun_Cb(data);
				}
			}
		});
	};

	owner.get = function(url, successFun_Cb, errorFun_Cb) {
		if (!url) {
			throw Error("url 不正确！");
			return false;
		}
		if (url && !url.match("^/")) {
			url = "/" + url;
		}
		var stateUser = owner.getState();
		if (stateUser.token) {
			if (url.indexOf("?") > -1) {
				url += "&token=" + stateUser.token;
			} else {
				url += "?token=" + stateUser.token;
			}
		}
		$.ajax(baseUrl + url, {
			type: "get",
			timeout: 10000,
			success: function(data) {
				if (data.ret == -2) { // 如果有数据回来，并且数据里面是用户信息过期的话
					owner.setState();
				}
				return successFun_Cb(data);
			},
			error: function(data) {
				return errorFun_Cb(data);
			}
		});
	};

	/**
	 * 保存设备信息
	 * @param {Object} 设备信息
	 * @param {Object} 保存后的回调函数
	 */
	owner.saveDeviceInfo = function(obj) { // 保存一些设备的信息到服务器，用于以后的推送消息

		var settings = owner.getSettings();
		if (!settings.deviceInfo) {
			owner.post("/device/info", obj, function(data) {
					if (data.ret) {
						settings["deviceInfo"] = true;
						owner.setSettings(settings);
					}
				},
				function(data) {

				}
			);
		}
	};
	/**
	 * 用户登录
	 **/
	owner.login = function(loginInfo, callback) {
		callback = callback || $.noop;
		loginInfo = loginInfo || {};
		loginInfo.account = loginInfo.account || '';
		loginInfo.password = loginInfo.password || '';
		if (loginInfo.account.length < 5) {
			return callback('账号最短为 5 个字符');
		}
		if (loginInfo.password.length < 6) {
			return callback('密码最短为 6 个字符');
		}
		owner.post("/user/logon", loginInfo, function(data) {
			if (data.ret) {
				owner.createState(data.data);
				return callback(data);
			} else {
				return callback(data);
			}
		}, function(data) {
			return callback(-1);
		});
	};
	
	owner.refreshUserInfo = function(loginInfo, callback) {
		callback = callback || $.noop;
		loginInfo = loginInfo || {};
		loginInfo.account = loginInfo.account || '';
		loginInfo.password = loginInfo.password || '';
		if (loginInfo.account.length < 5) {
			return callback('账号最短为 5 个字符');
		}
		if (loginInfo.password.length < 6) {
			return callback('密码最短为 6 个字符');
		}
		owner.post("/user/refreshUser", loginInfo, function(data) {
			if (data.ret) {
				owner.createState(data.data);
				return callback(data);
			} else {
				return callback(data);
			}
		}, function(data) {
			return callback(-1);
		});
	};

	owner.createState = function(data) {
		var state = owner.getState();
		state.user = data.user;
		state.nickName = data.nickname;
		state.token = data.accessToken;
		state.rights = data.rights;
		owner.setState(state);
	};

	/**
	 * 发送验证码
	 * @param {String} phonenumber
	 * @param {Function} callback
	 */
	owner.getVcode = function(phonenumber, callback) {
		owner.get("/user/sendMessage/" + phonenumber, function(data) {
			return callback(data);
		}, function(data) {
			return callback(-1);
		})
	}

	owner.validVcode = function(phonenumber, vcode, callback) {
		owner.post("/user/validateVerifyCode", {
			phoneNum: phonenumber,
			code: vcode
		}, function(data) {
			return callback(data);
		}, function(data) {
			return callback(-1);
		})
	}

	/**
	 * 新用户注册
	 **/
	owner.reg = function(regInfo, callback) {
		callback = callback || $.noop;
		regInfo = regInfo || {};
		regInfo.account = regInfo.account || '';
		regInfo.password = regInfo.password || '';
		regInfo.IMEI = regInfo.imei;
		regInfo.roleId = 1;

		owner.post("/user/saveUser", regInfo, function(data) {
			if (data.ret) {
				owner.createState(data.data);
			}
			return callback(data);
		},function(data) {
			return callback(-1);
		});
	};

	/**
	 * 找回密码
	 *
	 */
	owner.findPwd = function(obj, callBack) {
		owner.post("/user/findLosePassword", obj, function(data) {
				return callBack(data);
			},
			function(data) {
				return callBack(-1);
			}
		);

	};	
	/**
	 * 获取当前状态
	 **/
	owner.getState = function() {
		var stateText = localStorage.getItem('$userstate') || "{}";
		return JSON.parse(stateText);
	};

	/**
	 * 设置当前状态
	 **/
	owner.setState = function(state) {
		state = state || {};
		localStorage.setItem('$userstate', JSON.stringify(state));
		//var settings = owner.getSettings();
		//settings.gestures = '';
		//owner.setSettings(settings);
	};

	var checkEmail = function(email) {
		email = email || '';
		return (email.length > 3 && email.indexOf('@') > -1);
	};

	/**
	 * 找回密码
	 **/
	owner.forgetPassword = function(email, callback) {
		callback = callback || $.noop;
		if (!checkEmail(email)) {
			return callback('邮箱地址不合法');
		}
		return callback(null, '新的随机密码已经发送到您的邮箱，请查收邮件。');
	};

	/**
	 * 设置应用本地配置
	 **/
	owner.setSettings = function(key, value) {
		var settings = owner.getSettings();
		settings[key] = value;
		localStorage.setItem('$settings', JSON.stringify(settings));
	}

	/**
	 * 获取应用本地配置
	 **/
	owner.getSettings = function() {
			var settingsText = localStorage.getItem('$settings') || "{}";
			return JSON.parse(settingsText);
		}
		/**
		 * 获取指定的设置
		 * @param {String} key 键
		 */
	owner.getsetting = function(key) {
		var settingsText = localStorage.getItem('$settings') || "{}";
		if (!$.isEmptyObject(JSON.parse(settingsText))) {
			var settingsObj = JSON.parse(settingsText);
			return settingsObj[key] || "";
		}
		return null;
	}

	/**
	 * 获取本地分销商信息
	 **/
	owner.getFxs = function() {
		var stateText = localStorage.getItem('$fxs') || "{}";
		return JSON.parse(stateText);
	};

	/**
	 * 设置本地分销商信息
	 **/
	owner.setFxs = function(info) {
		var state = info || {};
		localStorage.setItem('$fxs', JSON.stringify(state));
	};

	/**
	 *  注销,清空本地存储的信息
	 */
	owner.userLogout = function() {
		owner.setState();
		owner.setFxs();
	};

	owner.putObj = function(key, value) {
		if ($.isPlainObject(value)) {
			value = JSON.stringify(value);
		}
		localStorage.setItem('$' + key, value);
	}
	owner.getObj = function(key) {
			var item = localStorage.getItem('$' + key) || {};
			return JSON.parse(item);
		}
		/*
　　　concat方法：返回一个新数组，这个新数组是由两个或更多数组组合而成的。
　　　　　　　　　这里就是返回this.slice(0,n)/this.slice(n+1,this.length)
　　 　　　　　　组成的新数组，这中间，刚好少了第n项。
　　　slice方法： 返回一个数组的一段，两个参数，分别指定开始和结束的位置。
　　*/
	owner.del = function(arr, n) {　　
		if (n < 0) {　　
			return arr;
		} else {　　
			return arr.slice(0, n).concat(arr.slice(n + 1, this.length));
		}
	}
	function contains(arr,a){
		for(var i = 0 ; i < arr.length; i++){
			if(arr[i] === a){
				return "";
			}
		}
		return a;
	}
	owner.isDirectly = function(city){
		var directlyCitys = ["北京","上海","天津","重庆"];
		return contains(directlyCitys,city);
	}
	
	owner.showWaiting = function(title){
		return plus.nativeUI.showWaiting(title,{background:"rgba(0,0,0,0.6)"});
	}
	
	owner.isIOS = function(){
		return plus.os.name == "iOS";
	}
	
	function toUnicode(theString) {
		//theString = 
		
		var unicodeString = escape(theString);
		
		unicodeString = unicodeString.replace(/%u/g,"\\u");
	  	/*for (var i = 0; i < theString.length; i++) {
	    	var theUnicode = theString.charCodeAt(i).toString(16);
		    while (theUnicode.length < 4) {
		      theUnicode = '0' + theUnicode;
		    }
	    	theUnicode = '\\u' + theUnicode;
	    	unicodeString += theUnicode;
	  	}*/
	  return unicodeString;
	}
	
	//不能输入表情符号 
	//[\ud83c\udc00-\ud83c\udfff]|[\ud83d\udc00-\ud83d\udfff]|[\u2600-\u27ff]
	var flag = true,i=0;
	$("body").on("input","input,textarea",function(){
		var tempValue = this.value;	
		if(flag){
			try{
			//var pattern = new RegExp("[\uD83D\uD83C][\udc00-\udfff]|[\u2600-\u27ff]","g");
			var pattern = new RegExp("[\uD83D\uD83C][\udc00-\udfff]","g");
			if(pattern.test(tempValue)){			
		    	var options = {
		     		duration : 'short'		     	
		     	}
					mui.toast("不支持表情及特殊符号输入!",options);
			 	}
				
				flag = false;
			}catch(e){
				console.log(e);
			}
		}else{
			setTimeout(function(){
				flag = true;
			},2000)
		}
		
		
	});
	//过滤表情和特殊符号
	(function(){
		var elm = document.querySelectorAll('input,textarea');
		for(var i = 0;i<elm.length;i++){
			elm[i].addEventListener('blur',function(){
				var _this = this;
				removeEmoji (_this);
			})
		}
		function removeEmoji (_this){
			var tempValue = _this.value;					
			try{						
				var pattern = new RegExp("[\uD83D\uD83C][\udc00-\udfff]","g");
				if(pattern.test(tempValue)){
					var value = tempValue.replace(pattern,""); 
					_this.value=value;
					mui.toast('您输入的表情及特殊符号已被过滤！');								
				}
				/*console.log(_this.value);*/
				
			}catch(e){
				console.log(e);
			}
		}
	})();
	
}(mui, window.app = {}));