(function($,fxs){
	
	/*
	 * 申请分销商
	 */
	fxs.disApply = function(postData,callBack){
		app.post("/dis/disApply",postData,function(data){
			return callBack(data);
		},function(data){
			return callBack(-1);
		});
	};
	
	/**
	 * 获取分销商详情信息
	 * @param {Object} disId 分销商Id
	 * @param {Object} callBack
	 */
	fxs.getDisInfo = function(disId,callBack){
		app.get("/dis/viewDis/"+disId,function(data){
			return callBack(data);
		},function(data){
			return callBack(-1);
		})
	}
	
	/**
	 * 保存logo
	 * @param {Object} postData
	 * @param {Object} callBack
	 */
	fxs.saveLogo = function(postData,callBack){
		app.post("/dis/editDisLogo",postData,function(data){
			return callBack(data);
		},function(data){
			return callBack(-1);
		});
	}
	/**
	 * 编辑基本信息
	 * @param {Object} postData
	 * @param {Object} callBack
	 */
	fxs.editBaseInfo = function(postData,callBack){
		app.post("/dis/editDis",postData,function(data){
			return callBack(data);
		},function(data){
			return callBack(-1);
		});
	}
	
	fxs.editAddr = function(postData,callBack){
		app.post("/dis/editComInfo",postData,function(data){
			return callBack(data);
		},function(data){
			return callBack(-1);
		});
	}
	
	fxs.editDisIntro = function(postData,callBack){
		app.post("/dis/editDisIntro",postData,function(data){
			return callBack(data);
		},function(data){
			return callBack(-1);
		});
	}
	
	fxs.del = function(method,id,callBack){
		app.get("/dis/"+method+"/"+id,function(data){
			return callBack(data);
		},function(data){
			return callBack(-1);
		});
	}
	
	fxs.editSZ = function(postData,callBack){
		app.post("/dis/editSZ",postData,function(data){
			return callBack(data);
		},function(data){
			return callBack(-1);
		});
	}
	
	fxs.invokeJS = function(methodName,postData,callBack){
		app.post("/dis/"+methodName,postData,function(data){
			return callBack(data);
		},function(data){
			return callBack(-1);
		});
	}
}(mui,window.fxs={}))
