(function($, owner) {


	/**
	 * 从服务器获取多次不绑定资源签名
	 */
	function getSignByFileId(fileId,callBack){
		app.get("/qc/get/"+fileId, function(data) {
			if (data.ret) {
				return callBack(data.data);
			}
		},function(data){
			mui.toast("获取认证信息出错!");
		});
		
	}
	
	function getSign(){
		var sign = plus.storage.getItem("qcloud_sign") || "{}";
		return JSON.parse(sign) ;
	}

	var uploadFiles = [];
	var saveStatus = false; //是否已经添加过事件
	owner.doUpload = function(options, success_cb) {
		var
		defaultOptions = {
			title: "选择图片",
			pickComplate: "",
			saveBtn:"",
			beforeSave:null,
			multiple:true
		}
		var sign = getSign();
		if($.isEmptyObject(sign)){
			$.alert("上传出错,没有签名认证信息!");
			return false;
		}
		
		//var server = sign.server+"?sign=" + encodeURIComponent(sign.sign);

		$.extend(true,
			defaultOptions, options);
		
		var btnArray = [{
			title: "打开相机"
		}, {
			title: "从相册选取"
		}];
		plus.nativeUI.actionSheet({
			title: defaultOptions.title+"(建议图片不大于2M)",
			cancel: "取消",
			buttons: btnArray
		}, function(e) {
			var index = e.index;
			switch (index) {
				case 0:
					break;
				case 1:
					appendByCamera();
					break;
				case 2:
					appendByGallery(defaultOptions.multiple);
					break;
			}
		});
		if(defaultOptions.saveBtn && !saveStatus){
			//console.log("添加保存事件");
			saveStatus = true; 
			document.getElementById(defaultOptions.saveBtn).addEventListener("tap",function(){
				var re = true;
				if(defaultOptions.beforeSave){
					re = defaultOptions.beforeSave();
				}
				if(re){
					upload(success_cb);
				}
			},false);
		}

		// 拍照添加文件
		function appendByCamera() {
				plus.camera.getCamera().captureImage(function(p) {
					plus.io.resolveLocalFileSystemURL( p, function ( entry ) {
						appendFile(entry.toLocalURL());
						if(!defaultOptions.saveBtn){
							upload(success_cb);
						}
					}, function ( e ) {
						plus.nativeUI.alert( "读取拍照文件错误："+e.message );
					});
					
				});
			}
			// 从相册添加文件

		function appendByGallery(multiple) {
			plus.gallery.pick(function(ev) {
				//console.log("选择图片路径:"+ev);
				if(multiple){
					for (var i = 0; i < ev.files.length; i++) {
						var p = ev.files[i];
						appendFile(p);
					}
				}else{
					appendFile(ev);
				}
				if(!defaultOptions.saveBtn){
					upload(success_cb);
				}
			}, function(e) {
				//mui.toast("选择相片出现错误!");
			}, {
				//filename: "FileContent",
				multiple: multiple
			});
		}
		function appendFile(f) {
			uploadFiles.push(f);
			if(defaultOptions.pickComplate){
				defaultOptions.pickComplate(f);
			}
		}
		
		function upload(success_cb) {
			if (uploadFiles.length > 0) {
				
				//console.log("开始上传：" + server)
				var bgTitle = defaultOptions.bgtitle ?  defaultOptions.bgtitle :"上传中,请稍后";
				var wt = plus.nativeUI.showWaiting(bgTitle,{
					background:"rgba(0,0,0,0.5)"
				});
				var uploadFilesLength = uploadFiles.length;
				var resultCount = 0;
				for (var i = 0; i < uploadFilesLength; i++) {
					var f = uploadFiles[i];
					
					//server = "http://192.168.0.100:8080/ask/upload"
					var task_i = plus.uploader.createUpload(sign.server, {
							method: "POST",
							timeout:30,
							retry:2,
							retryInterval:10
						},
						function(t, status) { //上传完成
							//console.log("上传返回信息:"+JSON.stringify(t));
							//console.log("上传返回状态:"+status);
							if (status == 200) {
								//console.log("上传成功：" + t.responseText);
								var convertData = JSON.parse(t.responseText).data;
								
								if(defaultOptions.title == "选择头像"){
									console.log("上传的是头像...");
								}else{
									convertData["sourcefile_url"] = convertData.download_url + "-source";
								}
								success_cb(1,convertData);
								resultCount++;
								if(resultCount == uploadFilesLength){
									wt.close();
								}
							} else {
								//console.log("上传失败,错误状态:");
								//console.log(t.responseText);
								$.toast(t.responseText);
								wt.close();
								success_cb(0,t.responseText);
							}
						}
					);
					task_i.setRequestHeader("Authorization",sign.sign);
					task_i.addFile(f, {
						key: "FileContent"
					});
					task_i.start();
				}
				uploadFiles = [];
			}else{
				success_cb(-1,{});
			}

		}
	}
	
	owner.removeUploadedFile = function(f){
		for(var i= 0;i < uploadFiles.length;i ++){
			if(f == uploadFiles[i]){
				uploadFiles =  uploadFiles.slice(0, i).concat(uploadFiles.slice(i + 1, uploadFiles.length));
				return;
			}
		}
	}
	/**
	 *  删除图片
	 * @param {Object} fileId
	 * @param {Object} success_cb
	 */
	owner.doDel = function(fileId,success_cb){
		getSignByFileId(fileId,function(data){
			var delServer = data.server+encodeURIComponent(fileId)+"/del?sign="+encodeURIComponent(data.sign);
			//console.log("删除连接:"+delServer);
			mui.post(delServer,{},function(data){
				//console.log("删除返回:"+JSON.stringify(data));
				return success_cb(data);
			},"json");
		});
	}
	

}(mui, window.qUploader = {}));